#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

void kernel_cpu(int *A0,int *A1,int *A2,int *A3,float *B0,float *B1,float *B2,float *B3,float *B4,float *B5,float *B6,float *B7,int N){
for(int i=0;i<N;i++){
A0[i] = A3[i]*A3[i]-A3[i]+A3[i];
A1[i] = A3[i];
A2[i] = A3[i];
B0[i] = B4[i]-B4[i]+B6[i];
}
}

int main(int argc,char **argv) {
int size=863763;
int intBytes = size*sizeof(int);
int floatBytes = size*sizeof(float);
int *A0;
A0 = (int *)malloc(intBytes);
int *A1;
A1 = (int *)malloc(intBytes);
int *A2;
A2 = (int *)malloc(intBytes);
int *A3;
A3 = (int *)malloc(intBytes);
float *B0;
B0 = (float *)malloc(floatBytes);
float *B1;
B1 = (float *)malloc(floatBytes);
float *B2;
B2 = (float *)malloc(floatBytes);
float *B3;
B3 = (float *)malloc(floatBytes);
float *B4;
B4 = (float *)malloc(floatBytes);
float *B5;
B5 = (float *)malloc(floatBytes);
float *B6;
B6 = (float *)malloc(floatBytes);
float *B7;
B7 = (float *)malloc(floatBytes);
for(int i=0;i<863763;i++){
A0[i] = 30*i+1;
A1[i] = 87*i+1;
A2[i] = 44+i+1;
A3[i] = 6*i+1;
B0[i] = 0.674270887766+i+1;
B1[i] = 34.545001646*i+1;
B2[i] = 20.872972487*i+1;
B3[i] = 53.4532797646*i+1;
B4[i] = 12.7790458784*i+1;
B5[i] = 0.166164211062+i+1;
B6[i] = 10.8070017755*i+1;
B7[i] = 58.2959972437*i+1;
}
struct timeval time0,time1;
gettimeofday(&time0,NULL);
FILE *file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "1";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
kernel_cpu(A0,A1,A2,A3,B0,B1,B2,B3,B4,B5,B6,B7,863763);
file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "0";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
gettimeofday(&time1,NULL);
double totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "CPU time: %lf msecs ",  (totaltime10)/1000.0F); 
free(A0);
free(A1);
free(A2);
free(A3);
free(B0);
free(B1);
free(B2);
free(B3);
free(B4);
free(B5);
free(B6);
free(B7);
printf("\n");return 0; }